libstdc++: __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc > Class Template Reference

libstdc++

__gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc > Class Template Reference
Extensions » Policy-Based Data Structures » Containers » Heap-Based » Base and Policy Classes

`#include <pairing_heap_.hpp>`

Inheritance diagram for __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >:
[legend]

## Public Types
typedef _Alloc | allocator_type
typedef Cmp_Fn | cmp_fn
typedef base_type::const_iterator | const_iterator
typedef __rebind_a::const_pointer | const_pointer
typedef __rebind_a::const_reference | const_reference
typedef _Alloc::difference_type | difference_type
typedef base_type::iterator | iterator
typedef left_child_next_sibling_heap_node_< Value_Type, null_type, _Alloc > | node
typedef base_type::point_const_iterator | point_const_iterator
typedef base_type::point_iterator | point_iterator
typedef __rebind_a::pointer | pointer
typedef __rebind_a::reference | reference
typedef _Alloc::size_type | size_type
typedef Value_Type | value_type

## Public Member Functions
| pairing_heap (const Cmp_Fn &)
| pairing_heap (const pairing_heap &)
iterator | begin ()
const_iterator | begin () const
void | clear ()
bool | empty () const
iterator | end ()
const_iterator | end () const
void | erase (point_iterator)
template<typename Pred>
size_type | erase_if (Pred)
Cmp_Fn & | get_cmp_fn ()
const Cmp_Fn & | get_cmp_fn () const
void | join (pairing_heap &)
size_type | max_size () const
void | modify (point_iterator, const_reference)
void | pop ()
point_iterator | push (const_reference)
size_type | size () const
template<typename Pred>
void | split (Pred, pairing_heap &)
void | swap (left_child_next_sibling_heap< Value_Type, Cmp_Fn, null_type, _Alloc > &)
void | swap (pairing_heap &)
const_reference | top () const

## Protected Types
typedef alloc_traits::allocator_type | node_allocator
typedef alloc_traits::const_pointer | node_const_pointer
typedef null_type | node_metadata
typedef std::pair< node_pointer, node_pointer > | node_pointer_pair

## Protected Member Functions
void | actual_erase_node (node_pointer)
void | bubble_to_top (node_pointer)
void | clear_imp (node_pointer)
template<typename It>
void | copy_from_range (It, It)
node_pointer | get_new_node_for_insert (const_reference)
node_pointer | prune (Pred)
void | swap_with_parent (node_pointer, node_pointer)
void | to_linked_list ()
void | value_swap (left_child_next_sibling_heap &)

## Static Protected Member Functions
static void | make_child_of (node_pointer, node_pointer)
static node_pointer | parent (node_pointer)

## Protected Attributes
node_pointer | m_p_root
size_type | m_size

## Detailed Description

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>
class __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >

Pairing heap.

Definition at line 77 of file pairing_heap_.hpp.

## Member Typedef Documentation

## ◆ allocator_type

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef _Alloc __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::allocator_type

Definition at line 88 of file pairing_heap_.hpp.

## ◆ cmp_fn

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef Cmp_Fn __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::cmp_fn

Definition at line 87 of file pairing_heap_.hpp.

## ◆ const_iterator

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::const_iterator __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::const_iterator

Definition at line 99 of file pairing_heap_.hpp.

## ◆ const_pointer

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef __rebind_a::const_pointer __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::const_pointer

Definition at line 93 of file pairing_heap_.hpp.

## ◆ const_reference

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef __rebind_a::const_reference __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::const_reference

Definition at line 95 of file pairing_heap_.hpp.

## ◆ difference_type

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef _Alloc::difference_type __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::difference_type

Definition at line 90 of file pairing_heap_.hpp.

## ◆ iterator

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::iterator __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::iterator

Definition at line 100 of file pairing_heap_.hpp.

## ◆ node

typedef left_child_next_sibling_heap_node_<Value_Type, null_type, _Alloc> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, null_type, _Alloc >::node
| inherited

Definition at line 95 of file left_child_next_sibling_heap_.hpp.

## ◆ node_allocator

typedef alloc_traits::allocator_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, null_type, _Alloc >::node_allocator
| protectedinherited

Definition at line 101 of file left_child_next_sibling_heap_.hpp.

## ◆ node_const_pointer

typedef alloc_traits::const_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, null_type, _Alloc >::node_const_pointer
| protectedinherited

Definition at line 104 of file left_child_next_sibling_heap_.hpp.

## ◆ node_metadata

typedef null_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, null_type, _Alloc >::node_metadata
| protectedinherited

Definition at line 105 of file left_child_next_sibling_heap_.hpp.

## ◆ node_pointer_pair

typedef std::pair<node_pointer, node_pointer> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, null_type, _Alloc >::node_pointer_pair
| protectedinherited

Definition at line 106 of file left_child_next_sibling_heap_.hpp.

## ◆ point_const_iterator

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::point_const_iterator __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::point_const_iterator

Definition at line 97 of file pairing_heap_.hpp.

## ◆ point_iterator

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::point_iterator __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::point_iterator

Definition at line 98 of file pairing_heap_.hpp.

## ◆ pointer

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef __rebind_a::pointer __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::pointer

Definition at line 92 of file pairing_heap_.hpp.

## ◆ reference

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef __rebind_a::reference __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::reference

Definition at line 94 of file pairing_heap_.hpp.

## ◆ size_type

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef _Alloc::size_type __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::size_type

Definition at line 89 of file pairing_heap_.hpp.

## ◆ value_type

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef Value_Type __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::value_type

Definition at line 86 of file pairing_heap_.hpp.

## Constructor & Destructor Documentation

## ◆ pairing_heap() [1/3]

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

__gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::pairing_heap | ( |  | ) |

Definition at line 56 of file pairing_heap_.hpp.

## ◆ pairing_heap() [2/3]

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

__gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::pairing_heap | ( | const Cmp_Fn & | r_cmp_fn | ) |

Definition at line 61 of file pairing_heap_.hpp.

## ◆ pairing_heap() [3/3]

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

__gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::pairing_heap | ( | const pairing_heap< Value_Type, Cmp_Fn, _Alloc > & | other | ) |

Definition at line 67 of file pairing_heap_.hpp.

## ◆ ~pairing_heap()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

__gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::~pairing_heap | ( |  | ) |

Definition at line 83 of file pairing_heap_.hpp.

## Member Function Documentation

## ◆ copy_from_range()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>
template<typename It>

void __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::copy_from_range | ( | It | first_it,
|  | It | last_it )
| protected

Definition at line 47 of file pairing_heap_.hpp.

## ◆ erase()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::erase | ( | point_iterator | it | ) |

Definition at line 64 of file pairing_heap_.hpp.

## ◆ erase_if()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>
template<typename Pred>

pairing_heap< Value_Type, Cmp_Fn, _Alloc >::size_type __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::erase_if | ( | Pred | pred | ) |

Definition at line 203 of file pairing_heap_.hpp.

## ◆ join()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::join | ( | pairing_heap< Value_Type, Cmp_Fn, _Alloc > & | other | ) |
| inline

Definition at line 94 of file pairing_heap_.hpp.

## ◆ modify()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::modify | ( | point_iterator | it,
|  | const_reference | r_new_val )

Definition at line 83 of file pairing_heap_.hpp.

## ◆ pop()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::pop | ( |  | ) |

Definition at line 46 of file pairing_heap_.hpp.

## ◆ push()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

pairing_heap< Value_Type, Cmp_Fn, _Alloc >::point_iterator __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::push | ( | const_reference | r_val | ) |
| inline

Definition at line 46 of file pairing_heap_.hpp.

## ◆ split()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>
template<typename Pred>

void __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::split | ( | Pred | pred,
|  | pairing_heap< Value_Type, Cmp_Fn, _Alloc > & | other )

Definition at line 47 of file pairing_heap_.hpp.

## ◆ swap()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::swap | ( | pairing_heap< Value_Type, Cmp_Fn, _Alloc > & | other | ) |

Definition at line 74 of file pairing_heap_.hpp.

## ◆ top()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

pairing_heap< Value_Type, Cmp_Fn, _Alloc >::const_reference __gnu_pbds::detail::pairing_heap< Value_Type, Cmp_Fn, _Alloc >::top | ( |  | ) | const
| inline

Definition at line 46 of file pairing_heap_.hpp.

## Member Data Documentation

## ◆ m_p_root

node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, null_type, _Alloc >::m_p_root
| protectedinherited

Definition at line 270 of file left_child_next_sibling_heap_.hpp.

## ◆ m_size

size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, null_type, _Alloc >::m_size
| protectedinherited

Definition at line 271 of file left_child_next_sibling_heap_.hpp.

The documentation for this class was generated from the following file:

- pairing_heap_.hpp